
  <!DOCTYPE html>
  <html>
    <head>
      <title>index.tsx</title>
      <link href="https://cdn.jsdelivr.net/npm/semantic-ui@2.4.2/dist/semantic.min.css" type="text/css" rel="stylesheet">
      <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.js" type="text/javascript" charset="utf-8"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/mode/javascript/javascript.min.js" type="text/javascript" charset="utf-8"></script>
<link href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.css" type="text/css" rel="stylesheet">
<script src="../../../../assets/source-file.js" type="text/javascript" charset="utf-8"></script>
<link href="../../../../assets/source-file.css" type="text/css" rel="stylesheet">
    </head>
    <body>
    <div style="margin-top:3em" class="ui container"><h1 class="ui header"><a href="../../../../index.html">TypeScript coverage report</a></h1><table style="margin-top:2em" class="ui celled table"><thead class=""><tr class=""><th class="">Filename</th><th class="">Percent</th><th class="">Threshold</th><th class="">Total</th><th class="">Covered</th><th class="">Uncovered</th></tr></thead><tbody class=""><tr class="positive"><td class="">src/pages/project-settings/index.tsx</td><td class="">98.87%</td><td class="">80%</td><td class="">1587</td><td class="">1569</td><td class="">18</td></tr></tbody></table><textarea id="editor" readonly="" style="margin-top:3em">import React, { useCallback, useEffect, useMemo, useState } from &#x27;react&#x27;;

import s from &#x27;./project-settings.module.scss&#x27;;
import { Header } from &#x27;../../components/Header/Header&#x27;;
import { Heading, HeadingVariant } from &#x27;../../components&#x27;;
import { Field } from &#x27;../../components/Field/Field&#x27;;
import { Button, ButtonVariant } from &#x27;../../components/Button/Button&#x27;;
import clsx from &#x27;clsx&#x27;;
import { Breadcrumbs } from &#x27;../../components/Breadcrumbs/Breadcrumbs&#x27;;
import { Paths } from &#x27;../../routes/paths&#x27;;
import { useHistory, useLocation, useParams } from &#x27;react-router-dom&#x27;;
import {
  useCreateProject,
  useProject as useQueryProject,
  useUpdateProject
} from &#x27;../../queries/projects&#x27;;
import {
  FitParameter,
  FitProcedure,
  GetQueryProjectSettings,
  ProjectSettings
} from &#x27;../../api/projectSettings&#x27;;
import {
  useCreateProjectSettings,
  useProjectSettings,
  useUpdateProjectSettings
} from &#x27;../../queries/projectSettings&#x27;;
import { FormFieldFloatTextValue } from &#x27;./components/FormFieldFloatTextValue&#x27;;
import { FormFieldRadio } from &#x27;./components/FormFieldRadio&#x27;;
import { FieldSpec, FormWrapper, useValidate } from &#x27;./components/FormContext&#x27;;
import { useIsCloneSelection } from &#x27;../../utils/useIsCloneSelection&#x27;;

export interface RadioProps&lt;Key&gt; {
  value: string;
  onChange: (value: Key) =&gt; void;
  title: string;
  options: { value: Key; label: string }[];
}

export const Radio = &lt;Key extends string&gt;({
  title,
  options,
  value = options[0].value,
  onChange
}: RadioProps&lt;Key&gt;) =&gt; {
  return (
    &lt;div className={s.Radio}&gt;
      &lt;div className={s.Radio__title}&gt;{title}&lt;/div&gt;
      &lt;div className={s.Radio__options}&gt;
        {options.map((opt) =&gt; {
          const isChecked = opt.value === value;
          return (
            &lt;div
              className={s.Radio__option}
              onClick={() =&gt; onChange(opt.value)}
            &gt;
              &lt;div className={s.Radio__checkWrapper}&gt;
                {&#x27; &#x27;}
                {isChecked ? &lt;div className={s.Radio__check} /&gt; : null}
              &lt;/div&gt;
              &lt;div className={s.Radio__optionText}&gt;{opt.label}&lt;/div&gt;
            &lt;/div&gt;
          );
        })}
      &lt;/div&gt;
    &lt;/div&gt;
  );
};

const MaxMinField = ({ prefix, title }: { title?: string; prefix: string }) =&gt; {
  return (
    &lt;div className={s.MaxMinField}&gt;
      &lt;div className={s.MaxMinField__title}&gt;{title}&lt;/div&gt;
      &lt;div className={s.MaxMinField__items}&gt;
        &lt;div className={s.MaxMinField__item}&gt;
          &lt;div className={s.MaxMinField__itemInput}&gt;
            &lt;FormFieldFloatTextValue
              fieldName={`${prefix}_lower_bound`}
              size=&quot;small&quot;
              className={s.MaxMinField__input}
            /&gt;
          &lt;/div&gt;
          &lt;div className={s.MaxMinField__itemPlaceholder}&gt;Min&lt;/div&gt;
        &lt;/div&gt;
        &lt;div className={s.MaxMinField__item}&gt;
          &lt;div className={s.MaxMinField__itemInput}&gt;
            &lt;FormFieldFloatTextValue
              fieldName={`${prefix}_upper_bound`}
              className={s.MaxMinField__input}
            /&gt;
          &lt;/div&gt;
          &lt;div className={s.MaxMinField__itemPlaceholder}&gt;Max&lt;/div&gt;
        &lt;/div&gt;
      &lt;/div&gt;
    &lt;/div&gt;
  );
};

const StepsField = ({ prefix, title }: { prefix: string; title?: string }) =&gt; {
  return (
    &lt;div className={s.MaxMinField}&gt;
      &lt;div className={s.MaxMinField__title}&gt;{title}&lt;/div&gt;
      &lt;div className={s.MaxMinField__items}&gt;
        &lt;div className={s.MaxMinField__item}&gt;
          &lt;div className={s.MaxMinField__itemInput}&gt;
            &lt;FormFieldFloatTextValue
              fieldName={`${prefix}_step1`}
              size=&quot;small&quot;
              className={s.MaxMinField__input}
            /&gt;
          &lt;/div&gt;
          &lt;div className={s.MaxMinField__itemPlaceholder}&gt;Step 1&lt;/div&gt;
        &lt;/div&gt;
        &lt;div className={s.MaxMinField__item}&gt;
          &lt;div className={s.MaxMinField__itemInput}&gt;
            &lt;FormFieldFloatTextValue
              fieldName={`${prefix}_step2`}
              size=&quot;small&quot;
              className={s.MaxMinField__input}
            /&gt;
          &lt;/div&gt;
          &lt;div className={s.MaxMinField__itemPlaceholder}&gt;Step 2&lt;/div&gt;
        &lt;/div&gt;
      &lt;/div&gt;
    &lt;/div&gt;
  );
};

const RadioWithInputs = &lt;Key extends string&gt;({
  title,
  options,
  withPlaceholder
}: {
  title?: string;
  options: { name: Key; title: string }[];
  withPlaceholder?: boolean;
}) =&gt; {
  return (
    &lt;div className={clsx(s.Radio, s.RadioWithInputs)}&gt;
      {title ? &lt;div className={s.Radio__title}&gt;{title}&lt;/div&gt; : null}
      &lt;div className={s.Radio__options}&gt;
        {options.map(({ title, name }) =&gt; {
          return (
            &lt;div className={s.Radio__option}&gt;
              &lt;div className={s.Radio__optionText}&gt;{title}&lt;/div&gt;
              {withPlaceholder &amp;&amp; (
                &lt;div className={s.Radio__optionPlaceholder} /&gt;
              )}
              &lt;div className={s.Radio__optionInput}&gt;
                &lt;FormFieldFloatTextValue
                  fieldName={name}
                  className={s.Radio__input}
                /&gt;
              &lt;/div&gt;
            &lt;/div&gt;
          );
        })}
      &lt;/div&gt;
    &lt;/div&gt;
  );
};

const modelConfiguringSteps = [&#x27;Data upload&#x27;, &#x27;Growth kinetics&#x27;];
const growthKineticsSteps = [&#x27;Growth kinetics&#x27;];
const simulationSteps = [&#x27;Growth kinetics&#x27;];

export const ProjectBreadcrumbs = () =&gt; {
  const { projectId = &#x27;&#x27; } = useParams&lt;{ projectId?: string }&gt;();
  const project = useQueryProject(projectId);
  const location = useLocation();

  const creatingStep = project?.project?.creating_step || &#x27;&#x27;;

  const isCloneSelection = location.pathname.includes(&#x27;clone-selection&#x27;);
  const cloneSelectionSteps = useMemo(
    () =&gt; [
      {
        title: &#x27;Growth kinetics fitting&#x27;,
        active: location.pathname.includes(&#x27;fitting&#x27;),
        passed: growthKineticsSteps.includes(creatingStep),
        to: Paths.CLONE_SELECTION_FITTING.replace(/:projectId/gi, projectId)
      },
      {
        title: &#x27;Simulation&#x27;,
        active: location.pathname.includes(&#x27;simulation&#x27;),
        passed: simulationSteps.includes(creatingStep),
        to: Paths.CLONE_SELECTION_SIMULATION.replace(/:projectId/gi, projectId)
      }
    ],
    [
      creatingStep,
      growthKineticsSteps,
      location.pathname,
      projectId,
      simulationSteps
    ]
  );
  const digitalTwinSteps = useMemo(
    () =&gt; [
      {
        title: &#x27;Additional configuration&#x27;,
        active: location.pathname.includes(&#x27;additional-configuration&#x27;),
        passed: modelConfiguringSteps.includes(creatingStep),
        to: Paths.DIGITAL_TWIN_ADDITIONAL_CONFIGURATION.replace(
          /:projectId/gi,
          projectId
        )
      }
    ],
    [creatingStep, location.pathname, modelConfiguringSteps, projectId]
  );
  const commonSteps = useMemo(
    () =&gt; [
      {
        title: &#x27;Data Upload&#x27;,
        active: location.pathname.includes(&#x27;create&#x27;),
        passed: true,
        to: isCloneSelection
          ? projectId
            ? Paths.CLONE_SELECTION_PROJECT_SETTINGS_EDIT.replace(
                /:projectId/gi,
                projectId
              )
            : Paths.CLONE_SELECTION_PROJECT_SETTINGS
          : projectId
          ? Paths.DIGITAL_TWIN_PROJECT_SETTINGS_EDIT.replace(
              /:projectId/gi,
              projectId
            )
          : Paths.DIGITAL_TWIN_PROJECT_SETTINGS
      },
      {
        title: &#x27;Model configuring&#x27;,
        active: location.pathname.includes(&#x27;model-configuration&#x27;),
        passed: modelConfiguringSteps.includes(creatingStep),
        to: (isCloneSelection
          ? Paths.CLONE_SELECTION_MODEL_CONFIGURATION
          : Paths.DIGITAL_TWIN_MODEL_CONFIGURATION
        ).replace(/:projectId/gi, projectId)
      }
    ],
    [
      creatingStep,
      isCloneSelection,
      location.pathname,
      modelConfiguringSteps,
      projectId
    ]
  );
  const steps = useMemo(() =&gt; {
    return commonSteps.concat(
      isCloneSelection ? cloneSelectionSteps : digitalTwinSteps
    );
  }, [cloneSelectionSteps, commonSteps, digitalTwinSteps, isCloneSelection]);
  return (
    &lt;Breadcrumbs
      steps={steps}
      title={
        &lt;div className={s.ProjectSettings__title}&gt;
          &lt;div className={s.ProjectSettings__titleMain}&gt;
            {project?.project?.name || &#x27;Project creation&#x27;}
          &lt;/div&gt;
          &lt;div className={s.ProjectSettings__titleName}&gt;
            {isCloneSelection ? &#x27;Clone selection&#x27; : &#x27;Digital twin&#x27;}
          &lt;/div&gt;
        &lt;/div&gt;
      }
    /&gt;
  );
};

type ComponentFitParameters = {
  primary_growth_rate_upper_bound: number;
  primary_growth_rate_lower_bound: number;
  primary_depth_rate_upper_bound: number;
  primary_depth_rate_lower_bound: number;
  toxicity_rate_upper_bound: number;
  toxicity_rate_lower_bound: number;
  lysing_rate_upper_bound: number;
  lysing_rate_lower_bound: number;
  biomaterial_inhibition_upper_bound: number;
  biomaterial_inhibition_lower_bound: number;
};
const mapComponentFitParametersToQueryFitParametersToUpdate = (
  componentFitParameters: Fields,
  prevFitParameters: (FitParameter &amp; { id: string })[]
): (FitParameter &amp; { id: string })[] =&gt; {
  return prevFitParameters.map((fitParam) =&gt; {
    switch (fitParam.name) {
      case &#x27;Primary growth rate&#x27;: {
        return {
          id: fitParam.id,
          name: &#x27;Primary growth rate&#x27;,
          role: &#x27;GROWTH_PARAMETER&#x27;,
          lower_bound: componentFitParameters.primary_growth_rate_lower_bound,
          upper_bound: componentFitParameters.primary_growth_rate_upper_bound
        };
      }
      case &#x27;Primary death rate&#x27;: {
        return {
          id: fitParam.id,
          name: &#x27;Primary death rate&#x27;,
          role: &#x27;GROWTH_PARAMETER&#x27;,
          lower_bound: componentFitParameters.primary_depth_rate_lower_bound,
          upper_bound: componentFitParameters.primary_depth_rate_upper_bound
        };
      }
      case &#x27;Toxicity rate&#x27;: {
        return {
          id: fitParam.id,
          name: &#x27;Toxicity rate&#x27;,
          role: &#x27;GROWTH_PARAMETER&#x27;,
          upper_bound: componentFitParameters.toxicity_rate_upper_bound,
          lower_bound: componentFitParameters.toxicity_rate_lower_bound
        };
      }
      case &#x27;Lysing rate&#x27;: {
        return {
          id: fitParam.id,
          name: &#x27;Lysing rate&#x27;,
          role: &#x27;GROWTH_PARAMETER&#x27;,
          lower_bound: componentFitParameters.lysing_rate_lower_bound,
          upper_bound: componentFitParameters.lysing_rate_upper_bound
        };
      }
      case &#x27;Bio material&#x27;: {
        return {
          id: fitParam.id,
          name: &#x27;Bio material&#x27;,
          role: &#x27;BUILT_IN&#x27;,
          type: &#x27;INHIBITOR_FACTOR&#x27;,
          threshold: {
            lower_bound:
              componentFitParameters.biomaterial_inhibition_lower_bound,
            upper_bound:
              componentFitParameters.biomaterial_inhibition_upper_bound
          }
        };
      }
    }
    return fitParam;
  });
};
const mapComponentFitParametersToQueryFitParameters = (
  componentFitParameters: ComponentFitParameters
): FitParameter[] =&gt; {
  return [
    {
      name: &#x27;Primary growth rate&#x27;,
      role: &#x27;GROWTH_PARAMETER&#x27;,
      lower_bound: componentFitParameters.primary_growth_rate_lower_bound,
      upper_bound: componentFitParameters.primary_growth_rate_upper_bound
    },
    {
      name: &#x27;Primary death rate&#x27;,
      role: &#x27;GROWTH_PARAMETER&#x27;,
      lower_bound: componentFitParameters.primary_depth_rate_lower_bound,
      upper_bound: componentFitParameters.primary_depth_rate_upper_bound
    },
    {
      name: &#x27;Toxicity rate&#x27;,
      role: &#x27;GROWTH_PARAMETER&#x27;,
      upper_bound: componentFitParameters.toxicity_rate_upper_bound,
      lower_bound: componentFitParameters.toxicity_rate_lower_bound
    },
    {
      name: &#x27;Lysing rate&#x27;,
      role: &#x27;GROWTH_PARAMETER&#x27;,
      lower_bound: componentFitParameters.lysing_rate_lower_bound,
      upper_bound: componentFitParameters.lysing_rate_upper_bound
    },
    {
      name: &#x27;Bio material&#x27;,
      role: &#x27;BUILT_IN&#x27;,
      type: &#x27;INHIBITOR_FACTOR&#x27;,
      threshold: {
        lower_bound: componentFitParameters.biomaterial_inhibition_lower_bound,
        upper_bound: componentFitParameters.biomaterial_inhibition_upper_bound
      }
    }
  ];
};

const initialFitParameters = {
  primary_growth_rate_lower_bound: 0.05,
  primary_growth_rate_upper_bound: 1.2,

  primary_depth_rate_lower_bound: 0.001,
  primary_depth_rate_upper_bound: 0.8,

  toxicity_rate_lower_bound: 0.000001,
  toxicity_rate_upper_bound: 0.1,

  lysing_rate_lower_bound: 0.1,
  lysing_rate_upper_bound: 2,

  biomaterial_inhibition_lower_bound: 10,
  biomaterial_inhibition_upper_bound: 250
};

const mapGetQueryDateTypeToComponentDateType = {
  Days: &#x27;DAYS&#x27;,
  Hours: &#x27;HOURS&#x27;
} as const;
const mapGetQueryObjectivePenaltyToComponentObjectivePenalty = {
  SQUARED: &#x27;SQUARED_ERROR&#x27;,
  SSE: &#x27;AUTO_CORRELATION&#x27;
} as const;
const mapGetQueryViableCellDensityTypeToComponentViableCellDensityType = {
  &#x27;cells/ml&#x27;: &#x27;NORMAL&#x27;,
  &#x27;1e6 cells/ml&#x27;: &#x27;E_SIX&#x27;,
  &#x27;1e5 cells/ml&#x27;: &#x27;E_FIVE&#x27;
} as const;

const mapGetQuerySourceToComponentSource = {
  &#x27;Lysed cells&#x27;: &#x27;LYSED_CELLS&#x27;,
  Biomaterial: &#x27;BIOMATERIAL&#x27;
} as const;

const mapQueryProjectSettingsToComponentProjectSettings = ({
  objective_penalty,
  date_type,
  viable_cell_density_type,
  source_of_toxicity,
  source_of_inhibition,
  ...projectSettings
}: GetQueryProjectSettings): ProjectSettings =&gt; ({
  ...projectSettings,
  objective_penalty:
    mapGetQueryObjectivePenaltyToComponentObjectivePenalty[objective_penalty],
  date_type: mapGetQueryDateTypeToComponentDateType[date_type],
  viable_cell_density_type:
    mapGetQueryViableCellDensityTypeToComponentViableCellDensityType[
      viable_cell_density_type
    ],
  source_of_toxicity: mapGetQuerySourceToComponentSource[source_of_toxicity],
  source_of_inhibition: mapGetQuerySourceToComponentSource[source_of_inhibition]
});
const mapQueryFitParametersToComponentFitParameters = (
  queryFitParameters: FitParameter[]
): ComponentFitParameters =&gt; {
  const params: ComponentFitParameters = { ...initialFitParameters };
  queryFitParameters.forEach((fitParameter) =&gt; {
    switch (fitParameter.name) {
      case &#x27;Primary growth rate&#x27;: {
        params.primary_growth_rate_lower_bound =
          fitParameter.lower_bound || params.primary_growth_rate_lower_bound;
        params.primary_growth_rate_upper_bound =
          fitParameter.upper_bound || params.primary_growth_rate_upper_bound;
        break;
      }

      case &#x27;Primary death rate&#x27;: {
        params.primary_depth_rate_lower_bound =
          fitParameter.lower_bound || params.primary_depth_rate_lower_bound;
        params.primary_depth_rate_upper_bound =
          fitParameter.upper_bound || params.primary_depth_rate_upper_bound;
        break;
      }
      case &#x27;Toxicity rate&#x27;: {
        params.toxicity_rate_lower_bound =
          fitParameter.lower_bound || params.toxicity_rate_lower_bound;
        params.toxicity_rate_upper_bound =
          fitParameter.upper_bound || params.toxicity_rate_upper_bound;
        break;
      }
      case &#x27;Lysing rate&#x27;: {
        params.lysing_rate_lower_bound =
          fitParameter.lower_bound || params.lysing_rate_lower_bound;
        params.lysing_rate_upper_bound =
          fitParameter.upper_bound || params.lysing_rate_upper_bound;

        break;
      }
      case &#x27;Bio material&#x27;: {
        params.biomaterial_inhibition_lower_bound =
          fitParameter.threshold?.lower_bound ||
          params.biomaterial_inhibition_lower_bound;
        params.biomaterial_inhibition_upper_bound =
          fitParameter.threshold?.upper_bound ||
          params.biomaterial_inhibition_upper_bound;
        break;
      }
    }
  });
  return params;
};
const initialProjectSettings: ProjectSettings = {
  fed_batch_call_density: 2,
  fed_batch_viability: 1,
  perfusion_bleed: 2,
  perfusion_viability: 1,
  objective_penalty: &#x27;AUTO_CORRELATION&#x27;,
  date_type: &#x27;DAYS&#x27;,
  viable_cell_density_type: &#x27;E_SIX&#x27;,
  bleed_controller_gain: 2e-3,
  bleed_controller_rest_time: 2,
  max_oxygen_rate: 25,
  perfusion_rate_threshold: 0.2,
  source_of_toxicity: &#x27;LYSED_CELLS&#x27;,
  source_of_inhibition: &#x27;BIOMATERIAL&#x27;
};
type ComponentFitProcedures = {
  number_of_particles_step1: number;
  iterations_step1: number;

  number_of_particles_step2: number;
  iterations_step2: number;
};
const initialComponentFitProcedures = {
  number_of_particles_step1: 75,
  iterations_step1: 25,

  number_of_particles_step2: 75,
  iterations_step2: 25
};
const mapComponentFitProceduresToQueryFitProceduresToUpdate = (
  componentFitProcedures: ComponentFitProcedures,
  prevFitProcedures: (FitProcedure &amp; { id: string })[]
): (FitProcedure &amp; { id: string })[] =&gt; {
  return prevFitProcedures.map((prevFitProcedure) =&gt; {
    switch (prevFitProcedure.step_name) {
      case &#x27;Exploration&#x27;: {
        return {
          id: prevFitProcedure.id,
          step_name: &#x27;Exploration&#x27;,
          number_of_particles: componentFitProcedures.number_of_particles_step1,
          iterations: componentFitProcedures.iterations_step1
        };
      }
      case &#x27;Refinement&#x27;: {
        return {
          id: prevFitProcedure.id,
          step_name: &#x27;Refinement&#x27;,
          number_of_particles: componentFitProcedures.number_of_particles_step2,
          iterations: componentFitProcedures.iterations_step2
        };
      }
    }
    return prevFitProcedure;
  });
};

const mapComponentFitProceduresToQueryFitProcedures = (
  componentFitProcedures: ComponentFitProcedures
): FitProcedure[] =&gt; {
  return [
    {
      step_name: &#x27;Exploration&#x27;,
      number_of_particles: componentFitProcedures.number_of_particles_step1,
      iterations: componentFitProcedures.iterations_step1
    },
    {
      step_name: &#x27;Refinement&#x27;,
      number_of_particles: componentFitProcedures.number_of_particles_step2,
      iterations: componentFitProcedures.iterations_step2
    }
  ];
};

const mapQueryFitProceduresToComponentFitProcedures = (
  queryFitProcedures: FitProcedure[]
): ComponentFitProcedures =&gt; {
  const componentFitProcedures: ComponentFitProcedures = {
    ...initialComponentFitProcedures
  };
  queryFitProcedures.forEach((fitProcedure) =&gt; {
    const value = {
      number_of_particles: fitProcedure.number_of_particles,
      iterations: fitProcedure.iterations
    };
    if (fitProcedure.step_name === &#x27;Refinement&#x27;) {
      componentFitProcedures.number_of_particles_step2 =
        value.number_of_particles;
      componentFitProcedures.iterations_step2 = value.iterations;
    } else if (fitProcedure.step_name === &#x27;Exploration&#x27;) {
      componentFitProcedures.number_of_particles_step1 =
        value.number_of_particles;
      componentFitProcedures.iterations_step1 = value.iterations;
    }
  });
  return componentFitProcedures;
};

const ActionsButtons = ({
  disabled,
  handleSave,
  isOpenAdvanced,
  onOpenAdvanced
}: {
  disabled?: boolean;
  handleSave: (isContinue?: boolean) =&gt; void;
  isOpenAdvanced: boolean;
  onOpenAdvanced: () =&gt; void;
}) =&gt; {
  const validate = useValidate();
  return (
    &lt;div className={s.ProjectSettings__actionButtons}&gt;
      &lt;Button
        hoverVariant={ButtonVariant.ACTION}
        disabled={disabled}
        onClick={() =&gt; {
          if (disabled) return;
          if (Object.keys(validate()).length === 0) {
            handleSave(false);
          }
        }}
      &gt;
        Save
      &lt;/Button&gt;
      &lt;Button
        hoverVariant={ButtonVariant.ACTION}
        disabled={disabled}
        onClick={() =&gt; {
          if (disabled) return;
          if (Object.keys(validate()).length === 0) {
            handleSave(true);
          }
        }}
      &gt;
        Save &amp; Continue
      &lt;/Button&gt;
      &lt;div
        className={s.ProjectSettings__actionButtonAdvanced}
        onClick={onOpenAdvanced}
      &gt;
        {isOpenAdvanced ? &#x27;Close&#x27; : &#x27;View&#x27;} advanced settings
      &lt;/div&gt;
    &lt;/div&gt;
  );
};

const initialFields = {
  ...initialProjectSettings,
  ...initialFitParameters,
  ...initialComponentFitProcedures
};

type Fields = ComponentFitProcedures &amp; ProjectSettings &amp; ComponentFitParameters;

const mapFieldsToProjectSettings = (fields: Fields): ProjectSettings =&gt; {
  return {
    fed_batch_call_density: fields.fed_batch_call_density,
    fed_batch_viability: fields.fed_batch_viability,
    perfusion_bleed: fields.perfusion_bleed,
    perfusion_viability: fields.perfusion_viability,
    objective_penalty: fields.objective_penalty,
    date_type: fields.date_type,
    viable_cell_density_type: fields.viable_cell_density_type,
    bleed_controller_gain: fields.bleed_controller_gain,
    bleed_controller_rest_time: fields.bleed_controller_rest_time,
    max_oxygen_rate: fields.max_oxygen_rate,
    perfusion_rate_threshold: fields.perfusion_rate_threshold,
    source_of_toxicity: fields.source_of_toxicity,
    source_of_inhibition: fields.source_of_inhibition
  };
};
export const ProjectSettingsPage = () =&gt; {
  const { projectId } = useParams&lt;{ projectId?: string }&gt;();
  const history = useHistory();
  const project = useQueryProject(projectId);
  const projectParameters = useProjectSettings(projectId);
  const isEdit = Boolean(projectId &amp;&amp; project);
  const [isOpenAdvanced, setOpenAdvanced] = useState(false);
  const [name, setName] = useState(&#x27;&#x27;);
  const [initialFile, setInitialFile] = useState&lt;File | null&gt;(null);
  const [fields, setFields] = useState&lt;Partial&lt;Fields&gt;&gt;({});
  const isCloneSelection = useIsCloneSelection();
  useEffect(() =&gt; {
    if (name === &#x27;&#x27; &amp;&amp; project.project?.name) {
      setName(project.project.name);
    }
  }, [name, project]);
  const {
    mutateAsync: mutateAsyncCreateProject,
    isLoading: isCreateProjectLoading
  } = useCreateProject();
  const {
    mutateAsync: mutateAsyncUpdateProject,
    isLoading: isUpdateProjectLoading
  } = useUpdateProject();
  const {
    mutateAsync: mutateAsyncCreateProjectSettings,
    isLoading: isCreateProjectSettingsLoading
  } = useCreateProjectSettings();
  const {
    mutateAsync: mutateAsyncUpdateProjectSettings,
    isLoading: isUpdateProjectSettingsLoading
  } = useUpdateProjectSettings();
  const isSomethingLoading =
    isCreateProjectLoading ||
    isUpdateProjectLoading ||
    isCreateProjectSettingsLoading ||
    isUpdateProjectSettingsLoading;

  useEffect(() =&gt; {
    let newFields: Partial&lt;Fields&gt; = {};
    if (!projectParameters.isLoading &amp;&amp; projectParameters.data) {
      if (projectParameters.data.fitProcedures.data) {
        newFields = {
          ...newFields,
          ...mapQueryFitProceduresToComponentFitProcedures(
            projectParameters.data.fitProcedures.data
          )
        };
      }
      if (projectParameters.data.fitParameters.data) {
        newFields = {
          ...newFields,
          ...mapQueryFitParametersToComponentFitParameters(
            projectParameters.data.fitParameters.data
          )
        };
      }
      if (projectParameters.data.projectSettings.data) {
        newFields = {
          ...newFields,
          ...mapQueryProjectSettingsToComponentProjectSettings(
            projectParameters.data.projectSettings.data
          )
        };
      }
      setFields(newFields);
    }
  }, [projectParameters.data, projectParameters.isLoading]);
  const handleUpdate = useCallback(async () =&gt; {
    await Promise.all([
      mutateAsyncUpdateProject({
        projectId: projectId as string,
        initialFile: initialFile ?? undefined,
        name
      }),

      mutateAsyncUpdateProjectSettings({
        projectId: projectId as string,
        fitParameters: mapComponentFitParametersToQueryFitParametersToUpdate(
          fields as Fields,
          projectParameters.data!.fitParameters.data
        ),
        fitProcedures: mapComponentFitProceduresToQueryFitProceduresToUpdate(
          fields as Fields,
          projectParameters.data!.fitProcedures.data
        ),
        projectSettings: {
          id: projectParameters.data!.projectSettings.data.id,
          ...mapFieldsToProjectSettings(fields as Fields)
        }
      })
    ]);
    return projectId as string;
  }, [
    fields,
    initialFile,
    mutateAsyncUpdateProject,
    mutateAsyncUpdateProjectSettings,
    name,
    projectId,
    projectParameters.data
  ]);
  const sendComplex = useCallback(async () =&gt; {
    const createProjectResult = await mutateAsyncCreateProject({
      initialFile: initialFile as File,
      name,
      type: isCloneSelection ? &#x27;CLONE_SELECTION&#x27; : &#x27;DIGITAL_TWIN&#x27;
    });
    await mutateAsyncCreateProjectSettings({
      projectId: createProjectResult.data.id,
      projectSettings: mapFieldsToProjectSettings(fields as Fields),
      fitProcedures: mapComponentFitProceduresToQueryFitProcedures(
        fields as Fields
      ),
      fitParameters: mapComponentFitParametersToQueryFitParameters(
        fields as Fields
      )
    });

    history.push(
      Paths.CLONE_SELECTION_PROJECT_SETTINGS_EDIT.replace(
        /:projectId/gi,
        createProjectResult.data.id
      )
    );
    return createProjectResult.data.id;
  }, [
    isCloneSelection,
    history,
    fields,
    initialFile,
    mutateAsyncCreateProject,
    mutateAsyncCreateProjectSettings,
    name
  ]);

  const handleSave = useCallback(
    async (isContinue) =&gt; {
      let projectId;
      if (isEdit) {
        projectId = await handleUpdate();
      } else {
        projectId = await sendComplex();
      }
      if (isContinue) {
        history.push(
          (isCloneSelection
            ? Paths.CLONE_SELECTION_MODEL_CONFIGURATION
            : Paths.DIGITAL_TWIN_MODEL_CONFIGURATION
          ).replace(/:projectId/, projectId)
        );
      }
    },
    [handleUpdate, history, isCloneSelection, isEdit, sendComplex]
  );

  const fieldsSpec = useMemo(
    () =&gt;
      [
        {
          name: &#x27;date_type&#x27;,
          title: &#x27;Time&#x27;,
          type: &#x27;radio&#x27;,
          options: [
            { label: &#x27;Days&#x27;, value: &#x27;DAYS&#x27; },
            { label: &#x27;Hours&#x27;, value: &#x27;HOURS&#x27; }
          ]
        },
        {
          name: &#x27;viable_cell_density_type&#x27;,
          title: &#x27;Viable cell density&#x27;,
          type: &#x27;radio&#x27;,
          options: [
            { label: &#x27;1e6 cells/ml&#x27;, value: &#x27;E_SIX&#x27; },
            { label: &#x27;1e5 cells/ml&#x27;, value: &#x27;E_FIVE&#x27; },
            { label: &#x27;cells/ml&#x27;, value: &#x27;NORMAL&#x27; }
          ]
        },
        {
          name: &#x27;primary_growth_rate_upper_bound&#x27;,
          type: &#x27;float&#x27;,
          min: Math.max(fields.primary_growth_rate_lower_bound || 1e-3, 1e-3),
          max: 5
        },
        {
          name: &#x27;primary_growth_rate_lower_bound&#x27;,
          type: &#x27;float&#x27;,
          min: 1e-3,
          max: 5
        },
        {
          name: &#x27;primary_depth_rate_upper_bound&#x27;,
          type: &#x27;float&#x27;,
          min: Math.max(fields.primary_depth_rate_lower_bound || 1e-5, 1e-5),
          max: 2
        },
        {
          name: &#x27;primary_depth_rate_lower_bound&#x27;,
          type: &#x27;float&#x27;,
          min: 1e-5,
          max: 2
        },
        {
          name: &#x27;toxicity_rate_upper_bound&#x27;,
          type: &#x27;float&#x27;,
          min: Math.max(fields.toxicity_rate_lower_bound || 1e-8, 1e-8),
          max: 0.5
        },
        {
          name: &#x27;toxicity_rate_lower_bound&#x27;,
          type: &#x27;float&#x27;,
          min: 1e-8,
          max: 0.5
        },
        {
          name: &#x27;lysing_rate_upper_bound&#x27;,
          type: &#x27;float&#x27;,
          min: Math.max(fields.lysing_rate_lower_bound || 0.1, 0.1),
          max: 5
        },
        {
          name: &#x27;lysing_rate_lower_bound&#x27;,
          type: &#x27;float&#x27;,
          min: 0.1,
          max: 5
        },
        {
          name: &#x27;biomaterial_inhibition_upper_bound&#x27;,
          type: &#x27;float&#x27;,
          min: Math.max(fields.biomaterial_inhibition_lower_bound || 1, 1),
          max: 500
        },
        {
          name: &#x27;biomaterial_inhibition_lower_bound&#x27;,
          type: &#x27;float&#x27;,
          min: 1,
          max: 500
        },
        {
          name: &#x27;number_of_particles_step1&#x27;,
          type: &#x27;int&#x27;,
          min: 10,
          max: 500
        },
        {
          name: &#x27;number_of_particles_step2&#x27;,
          type: &#x27;int&#x27;,
          min: 10,
          max: 500
        },
        {
          name: &#x27;iterations_step1&#x27;,
          type: &#x27;int&#x27;,
          min: 10,
          max: 500
        },
        {
          name: &#x27;iterations_step2&#x27;,
          type: &#x27;int&#x27;,
          min: 10,
          max: 500
        },
        {
          name: &#x27;objective_penalty&#x27;,
          title: &#x27;objective penalty&#x27;,
          type: &#x27;radio&#x27;,
          options: [
            { value: &#x27;SQUARED_ERROR&#x27;, label: &#x27;squared error&#x27; },
            { value: &#x27;AUTO_CORRELATION&#x27;, label: &#x27;auto correlation&#x27; }
          ]
        },
        {
          name: &#x27;fed_batch_call_density&#x27;,
          type: &#x27;float&#x27;,
          min: 0,
          max: 10
        },
        {
          name: &#x27;fed_batch_viability&#x27;,
          type: &#x27;float&#x27;,
          min: 0,
          max: 10
        },
        {
          name: &#x27;perfusion_bleed&#x27;,
          type: &#x27;float&#x27;,
          min: 0,
          max: 10
        },
        {
          name: &#x27;perfusion_viability&#x27;,
          type: &#x27;float&#x27;,
          min: 0,
          max: 10
        },
        {
          name: &#x27;bleed_controller_gain&#x27;,
          type: &#x27;float&#x27;,
          min: 1e-5,
          max: 1e-2
        },
        {
          name: &#x27;bleed_controller_rest_time&#x27;,
          type: &#x27;float&#x27;,
          min: 0.2,
          max: 5
        },
        {
          name: &#x27;max_oxygen_rate&#x27;,
          type: &#x27;float&#x27;,
          min: 10,
          max: 100
        },
        {
          name: &#x27;perfusion_rate_threshold&#x27;,
          type: &#x27;float&#x27;,
          min: 0,
          max: 2
        },
        {
          title: &#x27;Source of toxicity&#x27;,
          name: &#x27;source_of_toxicity&#x27;,
          type: &#x27;radio&#x27;,
          options: [
            { value: &#x27;LYSED_CELLS&#x27;, label: &#x27;Lysed cells&#x27; },
            { value: &#x27;BIOMATERIAL&#x27;, label: &#x27;Biomaterial&#x27; }
          ]
        },
        {
          title: &#x27;Source of inhibition&#x27;,
          name: &#x27;source_of_inhibition&#x27;,
          type: &#x27;radio&#x27;,
          options: [
            { value: &#x27;LYSED_CELLS&#x27;, label: &#x27;Lysed cells&#x27; },
            { value: &#x27;BIOMATERIAL&#x27;, label: &#x27;Biomaterial&#x27; }
          ]
        }
      ] as FieldSpec[],
    [
      fields.biomaterial_inhibition_lower_bound,
      fields.lysing_rate_lower_bound,
      fields.primary_depth_rate_lower_bound,
      fields.primary_growth_rate_lower_bound,
      fields.toxicity_rate_lower_bound
    ]
  );

  return (
    &lt;div className={s.ProjectSettings}&gt;
      &lt;FormWrapper
        defaultValues={initialFields}
        fields={fields}
        setFields={setFields}
        fieldsSpec={fieldsSpec}
      &gt;
        &lt;Header /&gt;
        &lt;ProjectBreadcrumbs /&gt;
        &lt;div className={s.ProjectSettings__content}&gt;
          &lt;Heading
            className={s.ProjectSettings__headingH2}
            variant={HeadingVariant.H2}
          &gt;
            Project Settings
          &lt;/Heading&gt;

          &lt;div className={s.ProjectSettings__shortInfo}&gt;
            &lt;Field
              className={s.ProjectSettings__shortInfoItem}
              label=&quot;Project name&quot;
              size=&quot;large&quot;
              value={name}
              onChange={setName}
            /&gt;

            &lt;Field
              value={isEdit ? project.project?.initial_data : undefined}
              onUpload={setInitialFile}
              label=&quot;Upload data file&quot;
              type=&quot;file&quot;
              size=&quot;large&quot;
              accept=&quot;.xls,.xlsx,.csv&quot;
            /&gt;
          &lt;/div&gt;
          {isOpenAdvanced &amp;&amp; (
            &lt;div&gt;
              &lt;Heading
                className={s.ProjectSettings__heading}
                variant={HeadingVariant.H3}
              &gt;
                Units
              &lt;/Heading&gt;
              &lt;div className={s.ProjectSettings__units}&gt;
                &lt;FormFieldRadio fieldName=&quot;date_type&quot; /&gt;
                &lt;FormFieldRadio fieldName=&quot;viable_cell_density_type&quot; /&gt;
              &lt;/div&gt;
              &lt;Heading
                className={s.ProjectSettings__heading}
                variant={HeadingVariant.H3}
              &gt;
                Kinetic limits
              &lt;/Heading&gt;
              &lt;div className={s.ProjectSettings__kineticLimits}&gt;
                &lt;MaxMinField
                  prefix=&quot;primary_growth_rate&quot;
                  title=&quot;max growth rate limit&quot;
                /&gt;
                &lt;MaxMinField prefix=&quot;primary_depth_rate&quot; title=&quot;death rate&quot; /&gt;
                &lt;MaxMinField prefix=&quot;toxicity_rate&quot; title=&quot;toxicity&quot; /&gt;
                &lt;MaxMinField prefix=&quot;lysing_rate&quot; title=&quot;lysing rate&quot; /&gt;
                &lt;MaxMinField
                  prefix=&quot;biomaterial_inhibition&quot;
                  title=&quot;biomaterial inhibition&quot;
                /&gt;
              &lt;/div&gt;
              &lt;Heading
                className={s.ProjectSettings__heading}
                variant={HeadingVariant.H3}
              &gt;
                Solver
              &lt;/Heading&gt;
              &lt;div className={s.ProjectSettings__solverFirstRow}&gt;
                &lt;StepsField
                  prefix=&quot;number_of_particles&quot;
                  title=&quot;number of particles&quot;
                /&gt;
                &lt;StepsField prefix=&quot;iterations&quot; title=&quot;number of iterations&quot; /&gt;
              &lt;/div&gt;
              &lt;div className={s.ProjectSettings__solverSecondRow}&gt;
                &lt;FormFieldRadio fieldName=&quot;objective_penalty&quot; /&gt;
                &lt;RadioWithInputs
                  withPlaceholder
                  title=&quot;weighting(fed-batch)&quot;
                  options={[
                    {
                      name: &#x27;fed_batch_call_density&#x27;,
                      title: &#x27;viable cell density&#x27;
                    },
                    { name: &#x27;fed_batch_viability&#x27;, title: &#x27;viability&#x27; }
                  ]}
                /&gt;
                &lt;RadioWithInputs
                  withPlaceholder
                  title=&quot;weighting(perfusion)&quot;
                  options={[
                    { name: &#x27;perfusion_bleed&#x27;, title: &#x27;bleed&#x27; },
                    { name: &#x27;perfusion_viability&#x27;, title: &#x27;viability&#x27; }
                  ]}
                /&gt;
              &lt;/div&gt;
              &lt;div className={s.ProjectSettings__row}&gt;
                &lt;div&gt;
                  &lt;Heading
                    className={s.ProjectSettings__heading}
                    variant={HeadingVariant.H3}
                  &gt;
                    Bleed control
                  &lt;/Heading&gt;
                  &lt;div className={s.ProjectSettings__inputParameter}&gt;
                    &lt;RadioWithInputs
                      withPlaceholder
                      options={[
                        {
                          name: &#x27;bleed_controller_gain&#x27;,
                          title: &#x27;Bleed control gain&#x27;
                        }
                      ]}
                    /&gt;
                    &lt;RadioWithInputs
                      withPlaceholder
                      options={[
                        {
                          name: &#x27;bleed_controller_rest_time&#x27;,
                          title: &#x27;Bleed control reset time&#x27;
                        }
                      ]}
                    /&gt;
                  &lt;/div&gt;
                &lt;/div&gt;
                &lt;div&gt;
                  &lt;Heading
                    className={s.ProjectSettings__heading}
                    variant={HeadingVariant.H3}
                  &gt;
                    Physical limitations
                  &lt;/Heading&gt;
                  &lt;div className={s.ProjectSettings__inputParameter}&gt;
                    &lt;RadioWithInputs
                      withPlaceholder
                      options={[
                        {
                          name: &#x27;max_oxygen_rate&#x27;,
                          title: &#x27;Max oxygen delivery time&#x27;
                        }
                      ]}
                    /&gt;
                  &lt;/div&gt;
                &lt;/div&gt;

                &lt;div /&gt;
                &lt;div&gt;
                  &lt;Heading
                    className={s.ProjectSettings__heading}
                    variant={HeadingVariant.H3}
                  &gt;
                    Inhibition and toxicity
                  &lt;/Heading&gt;
                  &lt;div className={s.ProjectSettings__inhibitionAndToxicity}&gt;
                    &lt;FormFieldRadio fieldName=&quot;source_of_toxicity&quot; /&gt;
                    &lt;FormFieldRadio fieldName=&quot;source_of_inhibition&quot; /&gt;
                  &lt;/div&gt;
                &lt;/div&gt;
                &lt;div&gt;
                  &lt;Heading
                    className={s.ProjectSettings__heading}
                    variant={HeadingVariant.H3}
                  &gt;
                    General parameters
                  &lt;/Heading&gt;
                  &lt;div className={s.ProjectSettings__inputParameter}&gt;
                    &lt;RadioWithInputs
                      withPlaceholder
                      options={[
                        {
                          name: &#x27;perfusion_rate_threshold&#x27;,
                          title: &#x27;Perfusion feed rate threshold&#x27;
                        }
                      ]}
                    /&gt;
                  &lt;/div&gt;
                &lt;/div&gt;
              &lt;/div&gt;
            &lt;/div&gt;
          )}
          &lt;ActionsButtons
            handleSave={handleSave}
            disabled={!name || (!isEdit &amp;&amp; !initialFile) || isSomethingLoading}
            isOpenAdvanced={isOpenAdvanced}
            onOpenAdvanced={() =&gt; setOpenAdvanced((s) =&gt; !s)}
          /&gt;
        &lt;/div&gt;
      &lt;/FormWrapper&gt;
    &lt;/div&gt;
  );
};
</textarea><pre id="annotations" style="display:none">[{&quot;file&quot;:&quot;src/pages/project-settings/index.tsx&quot;,&quot;line&quot;:728,&quot;character&quot;:19,&quot;text&quot;:&quot;projectId as string&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/project-settings/index.tsx&quot;,&quot;line&quot;:734,&quot;character&quot;:19,&quot;text&quot;:&quot;projectId as string&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/project-settings/index.tsx&quot;,&quot;line&quot;:736,&quot;character&quot;:10,&quot;text&quot;:&quot;fields as Fields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/project-settings/index.tsx&quot;,&quot;line&quot;:737,&quot;character&quot;:10,&quot;text&quot;:&quot;projectParameters.data!&quot;,&quot;kind&quot;:5},{&quot;file&quot;:&quot;src/pages/project-settings/index.tsx&quot;,&quot;line&quot;:740,&quot;character&quot;:10,&quot;text&quot;:&quot;fields as Fields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/project-settings/index.tsx&quot;,&quot;line&quot;:741,&quot;character&quot;:10,&quot;text&quot;:&quot;projectParameters.data!&quot;,&quot;kind&quot;:5},{&quot;file&quot;:&quot;src/pages/project-settings/index.tsx&quot;,&quot;line&quot;:744,&quot;character&quot;:14,&quot;text&quot;:&quot;projectParameters.data!&quot;,&quot;kind&quot;:5},{&quot;file&quot;:&quot;src/pages/project-settings/index.tsx&quot;,&quot;line&quot;:745,&quot;character&quot;:40,&quot;text&quot;:&quot;fields as Fields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/project-settings/index.tsx&quot;,&quot;line&quot;:749,&quot;character&quot;:11,&quot;text&quot;:&quot;projectId as string&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/project-settings/index.tsx&quot;,&quot;line&quot;:761,&quot;character&quot;:19,&quot;text&quot;:&quot;initialFile as File&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/project-settings/index.tsx&quot;,&quot;line&quot;:767,&quot;character&quot;:50,&quot;text&quot;:&quot;fields as Fields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/project-settings/index.tsx&quot;,&quot;line&quot;:769,&quot;character&quot;:8,&quot;text&quot;:&quot;fields as Fields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/project-settings/index.tsx&quot;,&quot;line&quot;:772,&quot;character&quot;:8,&quot;text&quot;:&quot;fields as Fields&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/pages/project-settings/index.tsx&quot;,&quot;line&quot;:794,&quot;character&quot;:11,&quot;text&quot;:&quot;isContinue&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/project-settings/index.tsx&quot;,&quot;line&quot;:795,&quot;character&quot;:10,&quot;text&quot;:&quot;projectId&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/project-settings/index.tsx&quot;,&quot;line&quot;:797,&quot;character&quot;:8,&quot;text&quot;:&quot;projectId&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/project-settings/index.tsx&quot;,&quot;line&quot;:799,&quot;character&quot;:8,&quot;text&quot;:&quot;projectId&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/pages/project-settings/index.tsx&quot;,&quot;line&quot;:801,&quot;character&quot;:10,&quot;text&quot;:&quot;isContinue&quot;,&quot;kind&quot;:1}]</pre></div>
    <p class="footer-text">TypeScript Coverage Report generated by <a href="https://github.com/plantain-00/type-coverage">type-coverage</a> and <a href="https://github.com/alexcanessa/typescript-coverage-report">typescript-coverage-report</a> at Tue, 05 Oct 2021 23:09:04 GMT</p>
    </body>
  </html>
  